
;NN		equ	1234h		; a sixteen bit number
;N		equ	56h		; an eight bit number

;F0=take THE next byte (8 bit)
;F1=take the TWO next bytes (16 bit)
;F2=special action ($+2)
;F3=special action ($+3)
;
;Multiple:	CB (FF)		;
;		DD (69d)		;NOT supported in Beta version
;		ED (54d)		;
;		FD (69d)		;

_opcodes:
.db	"nop",0				; 00
.db	"ld bc,",$F1,0			; 01 XX XX
.db	"ld (bc),a",0			; 02
.db	"inc bc",0				; 03
.db	"inc b",0				; 04
.db	"dec b",0				; 05
.db	"ld b,",$F0,0			; 06 XX
.db	"rlca",0				; 07
.db	"ex af,af",$27,0			; 08
.db	"add hl,bc",0			; 09
.db	"ld a,(bc)",0			; 0A
.db	"dec bc",0				; 0B
.db	"inc c",0				; 0C
.db	"dec c",0				; 0D
.db	"ld c,",$F0,0			; 0E XX
.db	"rrca",0				; 0F
.db	"djnz ",$F2,0			; 10
.db	"ld de,",$F1,0			; 11 XX XX
.db	"ld (de),a",0			; 12
.db	"inc de",0				; 13
.db	"inc d",0				; 14
.db	"dec d",0				; 15
.db	"ld d,",$F0,0			; 16 XX
.db	"rla",0				; 17
.db	"jr ",$F2,0				; 18
.db	"add hl,de",0			; 19
.db	"ld a,(de)",0			; 1A
.db	"dec de",0				; 1B
.db	"inc e",0				; 1C
.db	"dec e",0				; 1D
.db	"ld e,",$F0,0			; 1E XX
.db	"rra",0				; 1F
.db	"jr nz,",$F2,0			; 20
.db	"ld hl,",$F1,0			; 21 XX XX
.db	"ld (",$F1,"),hl",0		; 22 XX XX
.db	"inc hl",0				; 23
.db	"inc h",0				; 24
.db	"dec h",0				; 25
.db	"ld h,",$F0,0			; 26 XX
.db	"dda",0				; 27
.db	"jr z,",$F2,0			; 28
.db	"add hl,hl",0			; 29
.db	"ld hl,(",$F1,")",0		; 2A XX XX
.db	"dec hl",0				; 2B
.db	"inc l",0				; 2C
.db	"dec l",0				; 2D
.db	"ld l,",$F0,0			; 2E XX
.db	"cpl",0				; 2F
.db	"jr nc,",$F2,0			; 30
.db	"ld sp,",$F1,0			; 31 XX XX
.db	"ld (",$F1,"),a",0		; 32 XX XX
.db	"inc sp",0				; 33
.db	"inc (hl)",0			; 34
.db	"dec (hl)",0			; 35
.db	"ld (hl),",$F0,0			; 36 XX
.db	"scf",0				; 37
.db	"jr c,",$F2,0			; 38
.db	"add hl,sp",0			; 39
.db	"ld a,(",$F1,")",0		; 3A XX XX
.db	"dec sp",0				; 3B
.db	"inc a",0				; 3C
.db	"dec a",0				; 3D
.db	"ld a,",$F0,0			; 3E XX
.db	"ccf",0				; 3F
.db	"ld b,b",0				; 40
.db	"ld b,c",0				; 41
.db	"ld b,d",0				; 42
.db	"ld b,e",0				; 43
.db	"ld b,h",0				; 44
.db	"ld b,l",0				; 45
.db	"ld b,(hl)",0			; 46
.db	"ld b,a",0				; 47
.db	"ld c,b",0				; 48
.db	"ld c,c",0				; 49
.db	"ld c,d",0				; 4A
.db	"ld c,e",0				; 4B
.db	"ld c,h",0				; 4C
.db	"ld c,l",0				; 4D
.db	"ld c,(hl)",0			; 4E
.db	"ld c,a",0				; 4F
.db	"ld d,b",0				; 50
.db	"ld d,c",0				; 51
.db	"ld d,d",0				; 52
.db	"ld d,e",0				; 53
.db	"ld d,h",0				; 54
.db	"ld d,l",0				; 55
.db	"ld d,(hl)",0			; 56
.db	"ld d,a",0				; 57
.db	"ld e,b",0				; 58
.db	"ld e,c",0				; 59
.db	"ld e,d",0				; 5A
.db	"ld e,e",0				; 5B
.db	"ld e,h",0				; 5C
.db	"ld e,l",0				; 5D
.db	"ld e,(hl)",0			; 5E
.db	"ld e,a",0				; 5F
.db	"ld h,b",0				; 60
.db	"ld h,c",0				; 61
.db	"ld h,d",0				; 62
.db	"ld h,e",0				; 63
.db	"ld h,h",0				; 64
.db	"ld h,l",0				; 65
.db	"ld h,(hl)",0			; 66
.db	"ld h,a",0				; 67
.db	"ld l,b",0				; 68
.db	"ld l,c",0				; 69
.db	"ld l,d",0				; 6A
.db	"ld l,e",0				; 6B
.db	"ld l,h",0				; 6C
.db	"ld l,l",0				; 6D
.db	"ld l,(hl)",0			; 6E
.db	"ld l,a",0				; 6F
.db	"ld (hl),b",0			; 70
.db	"ld (hl),c",0			; 71
.db	"ld (hl),d",0			; 72
.db	"ld (hl),e",0			; 73
.db	"ld (hl),h",0			; 74
.db	"ld (hl),l",0			; 75
.db	"halt",0				; 76
.db	"ld (hl),a",0			; 77
.db	"ld a,b",0				; 78
.db	"ld a,c",0				; 79
.db	"ld a,d",0				; 7A
.db	"ld a,e",0				; 7B
.db	"ld a,h",0				; 7C
.db	"ld a,l",0				; 7D
.db	"ld a,(hl)",0			; 7E
.db	"ld a,a",0				; 7F
.db	"add a,b",0				; 80
.db	"add a,c",0				; 81
.db	"add a,d",0				; 82
.db	"add a,e",0				; 83
.db	"add a,h",0				; 84
.db	"add a,l",0				; 85
.db	"add a,(hl)",0			; 86
.db	"add a,a",0				; 87
.db	"adc a,b",0				; 88
.db	"adc a,c",0				; 89
.db	"adc a,d",0				; 8A
.db	"adc a,e",0				; 8B
.db	"adc a,h",0				; 8C
.db	"adc a,l",0				; 8D
.db	"adc a,(hl)",0			; 8E
.db	"adc a,a",0				; 8F
.db	"sub b",0				; 90
.db	"sub c",0				; 91
.db	"sub b",0				; 92
.db	"sub e",0				; 93
.db	"sub h",0				; 94
.db	"sub l",0				; 95
.db	"sub (hl)",0			; 96
.db	"sub a",0				; 97
.db	"sbc b",0				; 98
.db	"sbc c",0				; 99
.db	"sbc d",0				; 9A
.db	"sbc e",0				; 9B
.db	"sbc h",0				; 9C
.db	"sbc l",0				; 9D
.db	"sbc (hl)",0			; 9E
.db	"sbc a",0				; 9F
.db	"and b",0				; A0
.db	"and c",0				; A1
.db	"and d",0				; A2
.db	"and e",0				; A3
.db	"and h",0				; A4
.db	"and l",0				; A5
.db	"and (hl)",0			; A6
.db	"and a",0				; A7
.db	"xor b",0				; A8
.db	"xor c",0				; A9
.db	"xor d",0				; AA
.db	"xor e",0				; AB
.db	"xor h",0				; AC
.db	"xor l",0				; AD
.db	"xor (hl)",0			; AE
.db	"xor a",0				; AF
.db	"or b",0				; B0
.db	"or c",0				; B1
.db	"or d",0				; B2
.db	"or e",0				; B3
.db	"or h",0				; B4
.db	"or l",0				; B5
.db	"or (hl)",0				; B6
.db	"or a",0				; B7
.db	"cp b",0				; B8
.db	"CP c",0				; B9
.db	"cp d",0				; BA
.db	"cp e",0				; BB
.db	"cp h",0				; BC
.db	"cp l",0				; BD
.db	"cp (hl)",0				; BE
.db	"cp a",0				; BF
.db	"ret nz",0				; C0
.db	"pop bc",0				; C1
.db	"jp nz,",$F3,0			; C2
.db	"jp ",$F3,0				; C3
.db	"call nz,",$F1,0			; C4 XX XX
.db	"push bc",0				; C5
.db	"add a,",$F0,0			; C6 XX
.db	"rst 0",0				; C7
.db	"ret z",0				; C8
.db	"ret",0				; C9
.db	"jp z,",$F3,0			; CA
.db	"rlc b",0				; CB 00
.db	"call z,",$F1,0			; CC XX XX
.db	"call ",$F1,0			; CD XX XX
.db	"adc a,",$F0,0			; CE XX
.db	"rst 8h",0				; CF
.db	"ret nc",0				; D0
.db	"pop de",0				; D1
.db	"jp nc,",$F3,0			; D2
.db	"out (",$F0,"),a",0		; D3 XX
.db	"call nc,",$F1,0			; D4 XX XX
.db	"push de",0				; D5
.db	"sub ",$F0,0			; D6 XX
.db	"rst 10h",0				; D7
.db	"ret c",0				; D8
.db	"exx",0				; D9
.db	"jp c,",$F3,0			; DA
.db	"in a,(",$F0,")",0		; DB XX
.db	"call c,",$F1,0			; DC XX XX
.db	"add ix,bc",0			; DD 09
.db	"sbc a,",$F0,0			; DE XX
.db	"rst 18h",0				; DF
.db	"ret po",0				; E0
.db	"pop hl",0				; E1
.db	"jp po,",$F3,0			; E2
.db	"ex (sp),hl",0			; E3
.db	"call po,",$F1,0			; E4 XX XX
.db	"push hl",0				; E5
.db	"and ",$F0,0			; E6 XX
.db	"rst 20h",0				; E7
.db	"ret pe",0				; E8
.db	"jp (hl)",0				; E9
.db	"jp pe,",$F3,0			; EA
.db	"ex de,hl",0			; EB
.db	"call pe,",$F1,0			; EC XX XX
.db	"in b,(C)",0			; ED 40
.db	"xor ",$F0,0			; EE XX
.db	"rst 28h",0				; EF
.db	"ret p",0				; F0
.db	"pop af",0				; F1
.db	"jp p,",$F3,0			; F2
.db	"di",0				; F3
.db	"call p,",$F1,0			; F4 XX XX
.db	"push af",0				; F0
.db	"or ",$F0,0				; F6 XX
.db	"rst 30h",0				; F7
.db	"ret m",0				; F8
.db	"ld sp,hl",0			; F9
.db	"jp m,",$F3,0			; FA
.db	"ei",0				; FB
.db	"call m,",$F1,0			; FC XX XX
.db	"add iy,bc",0			; FD 09
.db	"cp ",$F0,0				; FE XX
.db	"rst 38h",0				; FF
