
ProgMenu:

	ld	a,6
	ld	e,5
	ld	b,5
	ld	c,42
	ld	hl,menu
	call	OpenWindow


	call	findprog
	call	next
	call	next

progloop:
	call	writeprogname
	call	_bufcopy
kprogl:
	call	$4014
	cp	$01
	jr	z,nextone
	cp	$36
	jr	z,openprog
	cp	$38
	jp	z,ReStart
	jr	kprogl
nextone:
	call	next
	or	a
	jr	z,ProgMenu
	jr	progloop
openprog:

	ld	hl,(progp)
	dec	hl			;move to ptr (skip var type)
	push	hl
	ld	b,(hl)
	dec	hl
	ld	h,(hl)
	ld	l,b			;now we are at the program
	inc	hl			;skip file length
	inc	hl
	ld	(progdata),hl

	pop	hl
	ld	a,(hl)
	ld	(progaddress),a
	dec	hl
	ld	a,(hl)
	ld	(progaddress+1),a
	ld	hl,(progaddress)
	ld	de,$02			;
	add	hl,de				;skip file length (2 bytes)
	ld	(progaddress),hl


	call	_clrlcd
	call	_bufclr

	call	_homeup

	ld	hl,(progaddress)
	push	hl
	ld	a,h
	call	_dispHex
	pop	hl
	ld	a,l
	call	_dispHex


;	call	_newline			;
;	ld	hl,(progdata)		;
;	dec	hl				;
;	ld	a,(hl)			;
;	dec	hl				;disp prog size
;	ld	b,(hl)			;
;	ld	h,a				;
;	ld	l,b				;
;	call	_disphl			;

;	call	_waitkey

	ld	hl,(progaddress)
	ld	(addressPTR),hl

	jp	ChooseViewers

;	ret


FindProg:
	ld	hl,(progptr)
find:	ld	(progp),hl
	ld	a,(hl)
	and	%00011111

	cp	$05
	jr	z,program
	cp	$06
	jr	z,program
	cp	$01
	jr	z,list
	cp	$0d
	jr	z,list

	xor	a
	ret

program:
;	ld	hl,(progp)
;	dec	hl
;	dec	hl
;	dec	hl
;	ld	b,(hl)
;	dec	hl
;	ld	a,(hl)
;	cp	$58		;X
;	jr	nz,no_good

	ld	a,1
	ret

no_good:
next:	ld	hl,(progp)
list:	dec	hl
	dec	hl
	dec	hl
	ld	b,(hl)
	inc	b
list_loop:
	dec	hl
	djnz	list_loop
	jr	find



WriteProgName:
	push	hl
	call	ClearSection
	pop	hl

	ld	de,20*256+55
	ld	(pencol),de
;	ld	hl,(progp)
;	call	_homeup
	dec	hl
	dec	hl
	dec	hl
	ld	b,(hl)
write:
	dec	hl
	ld	a,(hl)
;	call	_putc
	call	_vputmap
	djnz	write
	ret


ClearSection:
	ld	hl,plotsscreen+(12*20)+7

	ld	b,7
cbloop:
	push	bc
	ld	b,3
cloop:
	ld	(hl),$00
	inc	hl
	djnz	cloop
	ld	a,%00000001
	ld	(hl),a

	ld	de,12-3
	add	hl,de


	pop	bc
	djnz	cbloop
	ret



;+======================================================+

Disassembler:
	xor	a
	ld	(mode),a

	call	_clrlcd
	call	_bufclr


	xor	a	\	ld	(penrow),a


	CALL	DECODELINE		;
	ld	a,(temp)		;
	ld	(temp2),a		;
	ld	hl,(addressPTR)	;
	ld	(endAddress),hl	;
	ld	a,(penrow)		;
	add	a,7			;
	ld	(penrow),a		;


;	ld	b,9
	ld	b,9-1
BigLoop:
	push	bc
	CALL	DECODELINE
	ld	a,(penrow)
	add	a,7
	ld	(penrow),a
	pop	bc
	djnz	BigLoop

	call	_bufcopy

	ld	b,17
	ld	c,1
	ld	d,17
	ld	e,63
	ld	h,1
	call	_iline

	ld	b,58
	ld	c,1
	ld	d,58
	ld	e,63
	ld	h,1
	call	_iline

	ld	hl,(endAddress)
	ld	a,(temp2)
	inc	a
	ld	b,a
restore:
	dec	hl
	djnz	restore
	ld	(addressPTR),hl

	jp	mainLoop


;disskey:
;	ld	a,$0ff
;	out	(1),a
;	ld	a,$0bf
;	out	(1),a
;;	in	a,(1)
;	cp	127
;	jp	z,init
;
;	ld	a,$0ff
;	out	(1),a
;	ld	a,$0fe
;	out	(1),a
;	in	a,(1)
;	cp	247
;	jr	z,addup
;	cp	254
;	jr	z,dissdown
;	jr	disskey


;dissdown:
;	jp	disassembler


DECODELINE:
	xor	a
	ld	(temp),a

WriteAddress:
;	ld	a,0	\	ld	(penrow),a
	ld	a,1	\	ld	(pencol),a
	ld	hl,(addressPTR)
	push	hl
	ld	a,h
	call	_dispHex
	pop	hl
	ld	a,l
	call	_dispHex


	ld	hl,(addressPTR)
;	ld	a,0	\	ld	(penrow),a
	ld	a,19	\	ld	(pencol),a
WriteCode:
	ld	a,(hl)
;	cp	$CB			;
;	jp	z,Special		;-+-+-+-+-+-+-+-+----CBs
	cp	$FD
	jp	z,Special2
	call	_GetCode
ctn1:	call	_vputstring

ctn2:
	ld	hl,(addressPTR)
;	ld	a,0	\	ld	(penrow),a
	ld	a,60	\	ld	(pencol),a
	ld	a,(temp)
	inc	a
	ld	b,a
WriteHexCode:
	push	bc
	push	hl
	ld	a,(hl)
	call	_dispHex
	ld	a,' '
	call	_vputmap
	pop	hl
	inc	hl
	pop	bc
	djnz	WriteHexCode

	ld	(addressPTR),hl
	RET





_GetCode:
	ld	hl,_opcodes
tp1:	or	a
	ret	z
	ld	b,a
_getString:
	push	bc
	call	_skipString
	inc	hl
	pop	bc
	djnz	_getString
	ret

_skipString:
	ld	a,(hl)
	or	a
	ret	z
	inc	hl
	jr	_skipString



_vputstring:

_wsl:
	ld	a,(hl)
	or	a
	ret	z
	cp	$F0
	call	z,heightbit
	cp	$F1
	call	z,sixteenbit
	cp	$F2
	call	z,TESTLBL			;sixteenbit
	cp	$F3
	call	z,sixteenbit
	call	_vputmap
	inc	hl
	jr	_wsl
TESTLBL:
	ld	a,1
	ld	(temp),a

	push	hl

	ld	hl,(addressPTR)
	inc	hl
	ld	a,(hl)
	dec	hl

	push	af
	and	%10000000
	rla
	or	a
	jr	z,positiveJump
negativeJump:
	pop	af
	xor	$FC
	add	a,$02
	ld	b,a
backward:
	dec	hl
	djnz	backward
	jr	doneee


positiveJump:
	pop	af
	add	a,$02
	ld	e,a
	ld	d,$00
	add	hl,de
doneee:
	ld	a,h
	ld	b,l
	call	_dispHex
	ld	a,b
	call	_dispHex

	pop	hl
	ret

heightbit:
	ld	a,1
	ld	(temp),a
	push	hl

	ld	hl,(addressPTR)		;
	inc	hl				;
	ld	a,(hl)			;
	call	_dispHex			;

	pop	hl
	ret
sixteenbit:
	ld	a,2
	ld	(temp),a
	push	hl

	ld	hl,(addressPTR)		;
	inc	hl				;
	inc	hl				;
	ld	a,(hl)			;
	push	hl				;
	call	_dispHex			;
	pop	hl				;
	dec	hl				;
	ld	a,(hl)			;
	call	_dispHex			;

	pop	hl
	ret


;Special:
;	ld	a,1
;	ld	(temp),a
;	inc	hl
;;	ld	a,(hl)
;	cp	$01
;	jr	z,skip
;	sub	8
;skip:	dec	a
;	ld	hl,_CBs
;	call	tp1
;	jp	ctn1

Special2:
	ld	a,1
	ld	(temp),a
	inc	hl
	inc	hl
;	inc	hl
	ld	(addressPTR),hl
	jp	ctn2



;===========mainLoop

disUp:
	ld	hl,(endAddress)
	ld	a,(temp2)
	inc	a
	inc	a
	ld	b,a
restore2:
	dec	hl
	djnz	restore2
	ld	(addressPTR),hl
	jp	Disassembler

disDown:
	ld	hl,(endAddress)
;	ld	a,(temp2)
;	dec	a
;	ld	e,a
;	ld	d,$00
;	add	hl,de
	ld	(addressPTR),hl
	jp	Disassembler


.end
